#!perl

# P. 26 Algorithmic Beauty of Plants
# ABOP (c)1990 Springer-Verlag

# Shows the use of a color table.

# Perl L-System Implementation by:
# Sean O'Malley
# http://www.geocities.com/~ffrog

##################### DEFINES ########################

# Starting color (first color index is 1).
$colorstart = 1;
# Color table: 0-255 scale, RGB-ordered triplets:
@colortable = ( 133, 92, 46,
                173, 130, 61,
                153, 115, 56,
                0, 255, 0,
                25, 179, 0,
                25, 204, 25 );

# Angle (outputted to turtle information file).
# Leave at 0 if this should not be outputted.
$angle = 22.5;

# Output file
$file = 'turtle.lsd';

# Recursion level
$recurse = 7;

# Constructor (initial string).
$constructor = "A";

# Defines. Even constants should have quotation marks.

# Enumerate the characters used by (function) rules in this variable.
$functions = "AFSL";

# RULES
sub A {
   return "[&FL!A]/////'[&FL!A]///////'[&FL!A]";
}

sub F {
   return "S/////F";
}

sub S {
   return "FL";
}

sub L {
   return "['''^^{-f+f+f-|-f+f+f}]";
}

######################################################

if (!-e "param.pl") {
   print "Can't find PARAM.PL:\n";
   die "It contains the necessary code to run this.\n";
}

open(COMMANDS, "param.pl");
undef $/;
eval <COMMANDS>;
$/ = "\n";
close(COMMANDS);
