#!perl

# P. 59 Algorithmic Beauty of Plants
# ABOP (c)1990 Springer-Verlag

# Using the constants from figure "D" for the savannah-looking tree.
# Similar to P56EXAM.PL

# Perl L-System Implementation by:
# Sean O'Malley
# http://www.geocities.com/~ffrog

##################### DEFINES ########################

# Angle (outputted to turtle information file).
# Leave at 0 if this should not be outputted.
$angle = 0;

# Output file
$file = 'turtle.lsd';

# Recursion level
$recurse = 8;

# Constructor (initial string).
$constructor = "A(1,10)";

# Defines. Even constants should have quotation marks.
$r1 = "0.9";
$r2 = "0.8";
$a1 = "35";
$a2 = "35";
$wr = "0.707";

# Enumerate the characters used by the rules in this variable.
$functions = "AB";

# RULES

sub A {
   local($l, $w) = @_;
   return "!($w)F($l)[&($a1)B(".($l*$r1).",".($w*$wr).")]/(180)[&($a2)B(".($l*$r2).",".($w*$wr).")]";
}

sub B {
   local($l, $w) = @_;
   return "!($w)F($l)[+($a1)\$B(".($l*$r1).",".($w*$wr).")][-($a2)\$B(".($l*$r2).",".($w*$wr).")]";
}

######################################################

if (!-e "param.pl") {
   print "Can't find PARAM.PL:\n";
   die "It contains the necessary code to run this.\n";
}

open(COMMANDS, "param.pl");
undef $/;
eval <COMMANDS>;
$/ = "\n";
close(COMMANDS);
